"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _reactNative = require("react-native");
const LINKING_ERROR = "The package 'react-native-shake' doesn't seem to be linked. Make sure: \n\n" + _reactNative.Platform.select({
  ios: "- You have run 'pod install'\n",
  default: ''
}) + '- You rebuilt the app after installing the package\n' + '- You are not using Expo Go\n';

// @ts-expect-error
const isTurboModuleEnabled = global.__turboModuleProxy != null;
const ShakeModule = isTurboModuleEnabled ? require('./NativeShake').default : _reactNative.NativeModules.RNShake;
const Shake = ShakeModule ? ShakeModule : new Proxy({}, {
  get() {
    throw new Error(LINKING_ERROR);
  }
});
const eventEmitter = new _reactNative.NativeEventEmitter(Shake);
var _default = exports.default = {
  addListener: callback => {
    return eventEmitter.addListener('ShakeEvent', callback);
  },
  removeAllListeners: () => eventEmitter.removeAllListeners('ShakeEvent')
};
//# sourceMappingURL=index.js.map